<?php

/**
 * Created by PhpStorm.
 * User: chayton
 * Date: 2017/1/30
 * Time: 下午2:55
 */
namespace App\Service\DGJY;


use App\Models\DGJY\CompanyCert;
use App\Models\DGJY\CompanyCertFile;

class CompanyCertService
{
    private $companyCert;
    private $companyCertFile;

    public function __construct()
    {
        $companyCert = new CompanyCert();
        $companyCertFile = new CompanyCertFile();
        $this->companyCert = $companyCert;
        $this->companyCertFile = $companyCertFile;
    }


    /**
     * @return cert/certFile
     */
    public function getOneByWhere($table,Array $where,$field = Array('*'))
    {
        $types = ['cert','certFile'];
        if ( !in_array($table,$types) ){
            return false;
        }
        try{
            $model = null;
            switch ($table){
                case 'cert':
                    $model = $this->companyCert;
                    break;
                case 'certFile':
                    $model = $this->companyCertFile;
                    break;
            }
            $model = $model->select($field);
            foreach ($where as $key=>$value){
                $model = $model->where($key,$value);
            }
            return $model->first();
        }catch (\Exception $e){
            return false;
        }
    }

    /*
     * 插入企业资质信息
     * */

    public function insertInfo($table,Array $insertData=array())
    {
        $types = array('cert','certFile');
        if(!in_array($table,$types)){
            return false;
        }
        try{
            $model = null;
            switch($table){
                case 'cert':
                    $model = $this->companyCert;
                    break;
                case 'certFile':
                    $model = $this->companyCertFile;
                    break;
            }
            $insertData['created_at'] = time();
            $insertData['updated_at'] = time();
            $obj = $model->create($insertData);
            return $obj->id;
        }catch (\Exception $e){
            return false;
        }
    }

    /*
     * 更新企业资质信息
     * */

    public function UpdateByWhere($table,Array $where,Array $updateData=array())
    {
        $types = array('cert','certFile');
        if(!in_array($table,$types)){
            return false;
        }
        try{
            $model = null;
            switch($table){
                case 'cert':
                    $model = $this->companyCert;
                    break;
                case 'certFile':
                    $model = $this->companyCertFile;
                    break;
            }
            foreach($where as $key=>$value){
                $model = $model->where($key,$value);
            }
            $updateData['updated_at'] = time();
            $model->update($updateData);
            return true;
        }catch (\Exception $e){
            return false;
        }
    }

}