<?php
/**
 * Created by PhpStorm.
 * User: chayton
 * Date: 2017/1/31
 * Time: 下午8:33
 */

namespace App\Service\DGJY;


class PublicFun
{
    //对比本地和远程数据是否一致,不一致加入;
    public function HandleInfo($remote,$local)
    {
        if ( !count($remote) || !count($local) ){
            return false;
        }
        $result = [];
        foreach ( $remote as $key=>$value ){
            if ( $value != $local[$key] ){
                $result[$key] = $value;
            }
        }
        return $result;
    }

    //转换企业性质分类ID
    public function GetEntType($type_id){
        switch ($type_id)
        {
            case 100:return 1;break;//国有全资
            case 110:return 2;break;//集体全资
            case 130:return 3;break;//股份合作
            case 140:return 4;break;//联 营
            case 149:return 5;break;//其他联营
            case 142:return 6;break;//集体联营
            case 141:return 7;break;//国有联营
            case 150:return 8;break;//有限责任(公司)
            case 159:return 9;break;//股份有限公司
            case 160:return 10;break;//有限合伙企业
            default:return 0;break;//其它
        }
    }

    //日期格式化
    public function DateFormat($date){
        if ( $date ){
            return date($date);
        }
        return null;
    }

    //判断是否为空
    public function ValidData($string){
        $string = trim($string);
        if ( $string == '' or $string == '无' or $string == '/' ){
            return null;
        }
        return $string;
    }


    //转换资质名称
    public function ReplaceCertName($name){
        $name = trim($name);
        $name = str_replace('壹级','一级',$name);
        $name = str_replace('贰级','二级',$name);
        $name = str_replace('叁级','三级',$name);
        $name = str_replace('肆级','四级',$name);
        $name = str_replace('伍级','五级',$name);
        $name = str_replace('分项','',$name);
        switch ($name)
        {
            case '防水防腐保温工程专业承包二级':
                return '防腐防水防腐保温工程专业承包二级';
                break;
            case '防水防腐保温工程专业承包一级':
                return '防腐防水防腐保温工程专业承包一级';
                break;
            case '预拌混凝土专业承包不分 等级':
                return '预拌混凝土专业承包';break;
            case '公路交通工程（公路机电工程）专业承包':
                return '公路交通工程（公路机电工程）专业承包一级';
                break;
            case '公路交通工程（公路安全设施）专业承包':
                return '公路交通工程（公路安全设施）专业承包一级';
                break;
            case '特种工程专业承包不分等级':
                return '特种工程专业承包';
                break;
            case '特种工程专业承包（结构补强） 不分等级':
                return '特种工程（结构补强）专业承包';
                break;
            case '特种工程专业承包（建筑物纠偏和平移） 不分等级':
                return '特种工程（建筑物纠偏和平移）专业承包';
                break;
            case '特种工程专业承包（特种防雷） 不分等级':
                return '特种工程（特种防雷）专业承包';
                break;
            case '特种工程专业承包（特殊设备起重吊装）不分等级':
                return '特种工程（特种设备的起重吊装）专业承包';
                break;
            default:
                return $name;
                break;//其它
        }
    }


    /**
     * @合并同一证件，多个专业;
     */
    public function MergeData($arr)
    {
        $item = [];
        foreach($arr as $k=>$v){
            if(!isset($item[$v['cert_code']])){
                $item[$v['cert_code']]=$v;
            }else{
                $specialty = $this->ValidData($v['specialty']);
                if ( $specialty ){
                    $item[$v['cert_code']]['specialty'].=','.$specialty;
                }
            }
        }
        $item = array_values($item);
        return $item;
    }

    //查询远程对应的本地证件ID
    public function LocalCertID($cert_type,$cert_level,$cert_name,$cert_code)
    {
        if ( $cert_type == '注册证' ){
            if ( $cert_name == '注册建造师' ){
                if ($cert_level == '一级' or $cert_level == '壹级'){
                    return 2;
                }
                if ($cert_level == '二级' or $cert_level == '贰级'){
                    return 3;
                }
                return null;
            }
            if ( $cert_name == '临时注册建造师' ){
                if ($cert_level == '一级' or $cert_level == '壹级'){
                    return 4;
                }
                if ($cert_level == '二级' or $cert_level == '贰级'){
                    return 5;
                }
                return null;
            }
            if ( $cert_name == '注册造价工程师' ){
                return 10;
            }
        }
        if ( $cert_type == '安考证' ){
            $tmp_a = explode('安A',$cert_code);
            $tmp_b = explode('安B',$cert_code);
            if( count($tmp_a)>1 ){
                return 12;
            }
            if( count($tmp_b)>1 ){
                return 13;
            }
            return null;
        }
        return null;
    }


    /**
     * @转换证件名
     */
    public function TurnEmpty($cert_type,$cert_level,$cert_name,$cert_code){
        if ( $cert_type == '安考证' ){
            $tmp_a = explode('安A',$cert_code);
            $tmp_b = explode('安B',$cert_code);
            if( count($tmp_a)>1 ){
                return '企业负责人A证';
            }
            if( count($tmp_b)>1 ){
                return '企业项目负责人B证';
            }
            return '安考证';
        }
        if ( $cert_type == '注册证' ){
            if ( $cert_level ){
                return $cert_level.$cert_name;
            }
            return $cert_name;
        }
        if ( $cert_type == '其他证件' ){
            return '其他证件';
        }
        return $cert_name;
    }


    //查询远程对应的本地颁发机构ID
    public function LocalAgencyID($remote_data){
        if ( $remote_data == '住建部' ){
            return 3;
        }
        return null;
    }

}